var time;

$(function () {
  action();
  time = setTimeout(reflush(), 1000);
  clearTimeout(time);
});

//为了解决变体查询需要手动刷新的问题
function reflush() {
  chrome.tabs.getCurrent(function (tab) {
    var newUrl = tab.url;
    if (newUrl !== currentUrl) {
      action();
      time = setTimeout(reflush(), 1000);
    } else {
      time = setTimeout(reflush(), 1000);
    }
    clearTimeout(time);
  });
}

//保存当前页面URL地址
var currentUrl;

var action = function () {
  chrome.tabs.getCurrent(function (tab) {
    chrome.runtime.sendMessage({
      command: 'sellersprite_cmd_available_user',
      sender: 'content_scripts'
    }, function (resp) {
      keepa(encodeURIComponent(resp))
    });

    currentUrl = tab.url;

    function keepa(token) {
      var details = chrome.app.getDetails();
      /**
       * 获取版本号
       */
      var version = details.version;

      $($(".chart-loading p")[0]).append(chrome.i18n.getMessage("keepa_loadTip"));
      var p = $($(".chart-loading p")[1]);


      chrome.storage.sync.get("keepaNoticeTime", function (items) {
        if (new Date().getTime() - items.keepaNoticeTime > 1000 * 60 * 60 * 24) {
          $.get("https://www.sellersprite.com/v2/keepa/get/keepaNotice/" + details.current_locale, function (resp) {
            if (resp[0].valid === "true") {
              $("#ads").show();
              $($(p).find("span a")).before(resp[0].message);

              var data = {"keepaNotice": resp, "keepaNoticeTime": new Date().getTime()};
              chrome.storage.sync.set(data, function () {
                console.log("数据存储成功");
              })
            }
          }, "json");
        } else {
          chrome.storage.sync.get("keepaNotice", function (data) {
            console.log("本地缓存数据获成功");
            console.log(data[0]);
            $("#ads").show();
            $($(p).find("span a")).before(data[0].message);
          });
        }
      });


      var url = tab.url;

      /*
       * 解析出域名，包括协议
       */
      var urlReg = /https:\/\/[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+\.?/;
      var domain = urlReg.exec(url)[0];

      var site = new Map();
      site.set("https://www.amazon.com", "GLOBAL");
      site.set("https://www.amazon.co.uk", "UNITED_KINGDOM");
      site.set("https://www.amazon.de", "DE");
      site.set("https://www.amazon.fr", "FR");
      site.set("https://www.amazon.co.jp", "JP");
      site.set("https://www.amazon.ca", "CA");
      site.set("https://www.amazon.it", "IT");
      site.set("https://www.amazon.es", "ES");
      site.set("https://www.amazon.com.mx", "MX");
      site.set("https://www.amazon.in", "IN");
      site.set("https://www.amazon.com.au", "AU");

      var ctyc = new Map();
      ctyc.set("https://www.amazon.com", "US");
      ctyc.set("https://www.amazon.co.uk", "GB");
      ctyc.set("https://www.amazon.de", "DE");
      ctyc.set("https://www.amazon.fr", "FR");
      ctyc.set("https://www.amazon.co.jp", "JP");
      ctyc.set("https://www.amazon.ca", "CA");
      ctyc.set("https://www.amazon.it", "IT");
      ctyc.set("https://www.amazon.es", "ES");
      ctyc.set("https://www.amazon.com.mx", "MX");
      ctyc.set("https://www.amazon.in", "IN");
      ctyc.set("https://www.amazon.com.au", "AU");

      var regex = RegExp(domain + "/([\\w-]+/)?(dp|gp/product)/(\\w+/)?(\\w{10})");
      var asinArr = url.match(regex);
      var asin = "";

      try {
        asin = asinArr[4];
      } catch (e) {
        var urlSplit = url.split("/");
        asin = urlSplit[5];
        if (url.indexOf("gp/product") > -1) {
          asin = urlSplit[6];
        }

        if (asin.indexOf("?") > -1) {
          asin = asin.split("?")[0];
        }
      }

      chrome.runtime.sendMessage({
        command: 'sellersprite-keepa-user-action'
      }, function (resp) {
        console.log("接收的值: " + resp);
        console.log(typeof (resp));
        if (resp === "open") {
          open(details, version, url, domain, site, ctyc, asin, token);
        }
      });
    }

  });
};

function open(details, version, url, domain, site, ctyc, asin, token) {
  var _url = window.location.href;
  var _utl_split = _url.split("?");

  var range;
  if (_utl_split.length > 1) {
    range = _utl_split[1].split("=")[1];
  }

  // var cacheData = localStorage["sellersprite-keepa-data-" + asin];
  // /**
  //  * 如果本地缓存中存在数据则从缓存中读取，否则从服务器上获取。
  //  */
  // if (cacheData !== undefined) {
  //   cacheData = JSON.parse(cacheData);
  //   var totalDays = cacheData.data.totalDays;
  //   var dataZoomStart = range !== undefined && range === "-1" ? 0 : 30;
  //
  //   if (range === undefined) {
  //     range = 180;
  //   }
  //
  //   if (range !== '-1') {
  //     dataZoomStart = (1 - range / totalDays) * 100;
  //   }
  //
  //   cacheData.data.dataZoomStart = dataZoomStart;
  //   initEchart(cacheData, version, details, ctyc, domain, asin, range);
  //   return;
  // }

  var qid = null;
  $.ajax({
    type: "GET",
    url: "https://www.sellersprite.com/v2/keepa/qid/" + site.get(domain) + "/" + asin,
    dataType: "json",
    async: false,
    complete: function (xhr, status) {
      console.log("xhr");
      console.log(xhr);
      qid = xhr.responseText;
    }
  });

  if (qid !== null && qid !== {}) {
    $.ajax({
      type: "GET",
      url: "https://www.sellersprite.com/v2/keepa/get/" + site.get(domain) + "/" + asin
        + "?token=" + token + "&language=" + details.current_locale + "&version=" + version + (range !== undefined ? "&range=" + range : "")
        + "&qid=" + qid,
      dataType: "json",
      async: false,
      success: function (result) {
        initEchart(result, version, details, ctyc, domain, asin, range);
      }
    });
  }

  /*$.ajax({
    type: "GET",
    url: "https://www.sellersprite.com/v2/keepa/get/" + site.get(domain) + "/" + asin
      + "?token=" + token + "&language=" + details.current_locale + "&version=" + version + (range !== undefined ? "&range=" + range : ""),
    dataType: "json",
    success: function (result) {
      initEchart(result, version, details, ctyc, domain, asin, range);
    }
  });*/
}

function initEchart(result, version, details, ctyc, domain, asin, range) {
  if (result.code === 0) {
    var currency = result.data.currency;
    // localStorage.setItem("sellersprite-keepa-data-" + asin, JSON.stringify(result));
    if (result.version !== version) {
      $(".chart-tip").show();
    }

    if (JSON.stringify(result.data.keepa) === "{}") {
      //这里需要跳转到缺省页
      window.location.href = chrome.extension.getURL('injects/nodata.html');
      return;
    }

    var dom = document.getElementById("container");
    var myChart = echarts.init(dom);
    var app = {};
    var timeMap = result.data.times;//['201-2019/01/01','2019/01/02','2019/01/03','2019/01/04','2019/01/05','2019/01/06','2019/01/07'];


    var xAxisData = new Map();
    var timeData = new Array();

    for (var i = 0; i < timeMap.length; i++) {
      var time = timeMap[i];
      time = time.split(" ")[0].split("-");

      var key = time[1] + "/" + time[0];
      if (xAxisData.get(key) !== undefined) {
        timeData[i] = "";
      } else {
        xAxisData.set(key, i);
        timeData[i] = key;
      }
    }

    option = null;
    option = {
      title: {
        text: chrome.i18n.getMessage("keepa_extName"),//'卖家精灵运营专家',
        textStyle: {
          width: '200px',
          fontSzie: '15px',
          color: '#FF9300',
          rich: {}
        },
        subtext: chrome.i18n.getMessage("keepa_extNameTitleSubtext"),//'关键词优化 | 大数据选品\n\n{a|}',
        subtextStyle: {
          width: '200px',
          fontSzie: '12px',
          color: '#B1B5B9',
          rich: {
            a: {
              width: 148,
              height: result.data.ads[0].image === "" ? 0 : 65,
              backgroundColor: {
                image: result.data.ads[0].image//banner.jpg
              }
            }
          }
        },
        top: '30',
        right: '20'
      },
      tooltip: {
        trigger: 'axis',
        axisPointer: {
          type: 'cross',
          label: {
            backgroundColor: 'rgba(0, 0, 0, .7)'
          }
        },
        padding: [5, 10],
        backgroundColor: 'rgba(0, 0, 0, .7)',
        formatter: function (params) { //这里是格式化弹层渲染
          var text = params[0].axisValue;
          var arrs = new Array();
          params.forEach(function (item) {
            arrs[item.seriesIndex] = item;
          });

          arrs.forEach(function (item) {
            let unit = item.seriesName.indexOf(chrome.i18n.getMessage("keepa_price")/*'价格'*/) > -1 ? currency : '';
            var data = item.data;
            var _result;

            if (item.seriesName.indexOf(chrome.i18n.getMessage("keepa_price")/*'价格'*/) > -1 ||
              item.seriesName.indexOf(chrome.i18n.getMessage("keepa_dealPrice")/*'deal价格'*/) > -1 ||
              item.seriesName.indexOf(chrome.i18n.getMessage("keepa_buyboxPrice")/*'buybox价格'*/) > -1
            ) {
              //data = Math.floor(data * 100) / 100;
              _result = data >= 1000000 ? data / 1000000 + "M" : data > 9999 ? data / 1000 + "K" : price(data)
            } else if (item.seriesName.indexOf(chrome.i18n.getMessage("keepa_bsrRanking")) > -1) {
              _result = rounding(toThousands(data));
            } else if (item.seriesName.indexOf(chrome.i18n.getMessage("keepa_rating")) > -1) {
              _result = data;
            } else if (item.seriesName.indexOf(chrome.i18n.getMessage("keepa_reviews")) > -1) {
              _result = rounding(toThousands(data));
            } else {
              _result = data >= 1000000 ? data / 1000000 + "M" : data >= 1000 ? data / 1000 + "K" : data;
            }
            text += '<br/>' + item.marker + item.seriesName + '   ' + '<span style="float: right; margin-left: 20px">' + unit + _result + '</span>'
            //text += '<br/>' + item.marker + item.seriesName + '   ' + '<span style="float: right; margin-left: 20px">' + unit + (item.data >= 1000000 ? item.data / 1000000 + "M" : item.data >= 1000 ? item.data / 1000 + "K" : item.data) + '</span>'
          });
          return text;
        }
      },
      legend: {
        //data:['价格','BSR排名', '评分', '评论数', '卖家数', 'Deal价格', 'Buybox价格'],
        data: [
          chrome.i18n.getMessage("keepa_price"),
          chrome.i18n.getMessage("keepa_bsrRanking"),
          chrome.i18n.getMessage("keepa_reviews"),
          chrome.i18n.getMessage("keepa_rating"),
          chrome.i18n.getMessage("keepa_seller"),
          chrome.i18n.getMessage("keepa_dealPrice"),
          chrome.i18n.getMessage("keepa_buyboxPrice")
        ],
        orient: 'vertical',
        width: '200px',
        itemGap: 15,
        top: '205',
        right: '65',
        //默认不显示的图例都设置成false即可
        selected: details.current_locale === "en" || details.current_locale === "en_US" ? {
          'Buybox Price': false,
          'Deal Price': false,
          'Sellers': false
        } : details.current_locale === "ja" ? {
          'Buybox価格': false,
          'Deal価格': false,
          'セラー数': false
        } : {
          'Buybox价格': false,
          'Deal价格': false,
          '卖家数': false
        }
      },
      grid: [{
        left: 50,
        right: 230,
        height: '32%'
      }, {
        left: 50,
        right: 230,
        top: '54%',
        height: '35%'
      }],
      toolbox: {
        top: '170',
        right: 65,
        feature: {
          dataZoom: {
            yAxisIndex: 'none',
            title: {
              zoom: chrome.i18n.getMessage("keepa_timeIntervalAdjustment"),//'Time Interval Adjustment',
              back: chrome.i18n.getMessage("keepa_restoreTheTimeInterval")//'Restore the Time Interval'
            },
            emphasis: {
              iconStyle: {
                borderColor: '#FF9300'
              }
            }
          },
          restore: {
            title: chrome.i18n.getMessage("keepa_restore"),//'Restore',
            emphasis: {
              iconStyle: {
                borderColor: '#FF9300'
              }
            }
          },
          saveAsImage: {
            title: chrome.i18n.getMessage("keepa_saveAsImage"),//'Save as image',
            name: "SellerSprite-" + ctyc.get(domain) + "-" + asin + "-" + new Date().format("yyyyMMdd"),
            emphasis: {
              iconStyle: {
                borderColor: '#FF9300'
              }
            }
          }
        }
      },
      axisPointer: {
        link: {xAxisIndex: 'all'}
      },
      dataZoom: [
        {
          show: true,
          realtime: true,
          start: result.data.dataZoomStart,
          end: 100,
          xAxisIndex: [0, 1]//0,1,2,3
        },
        {
          type: 'slider',
          realtime: true,
          start: result.data.dataZoomStart,
          end: 100,
          xAxisIndex: [0, 1, 2, 3],//0,1,2,3
          borderColor: '#E5E7EC',
          dataBackground: {
            lineStyle: {
              color: '#E7ECF7'
            },
            areaStyle: {
              color: '#F2F5FB'
            }
          },
          fillerColor: 'rgba(229,234,245,.4)'
        }
      ],
      xAxis: [
        {
          type: 'category',
          boundaryGap: false,
          axisLine: {
            onZero: true,
            lineStyle: {
              color: '#E5E7EC'
            }
          },
          axisLabel: {
            color: '#7B7E81',
            // interval: 1
            formatter: function (value) {
              return value.split(" ")[0];
            }
          },
          data: timeMap/*timeData*/,
          position: 'bottom'
        },
        {
          type: 'category',
          boundaryGap: false,
          axisLine: {
            onZero: true,
            lineStyle: {
              color: '#E5E7EC'
            }
          },
          axisLabel: {
            color: '#7B7E81'
          },
          show: false,
          data: timeMap/*timeData*/,
          position: 'bottom'
        },
        {
          gridIndex: 1,
          type: 'category',
          boundaryGap: false,
          show: false,
          axisLine: {
            onZero: true,
            lineStyle: {
              color: '#E5E7EC'
            }
          },
          axisLabel: {
            show: false,
            color: '#7B7E81'
          },
          data: timeMap/*timeData*/,
          position: 'bottom'
        },
        {
          gridIndex: 1,
          type: 'category',
          boundaryGap: false,
          axisLine: {onZero: true},
          show: false,
          data: timeMap/*timeData*/,
          position: 'bottom'
        }
      ],
      yAxis: [
        {
          name: '',
          type: 'value',
          splitLine: {
            show: false
          },
          axisLine: {
            lineStyle: {
              color: '#E5E7EC'
            }
          },
          axisLabel: {
            color: '#7B7E81',
            formatter: function (value) { //上图左边y轴 价格
              return toThousands(value);// >= 1000000 ? value / 1000000 + "M" : value >= 1000 ? value / 1000 + "K" : value;
            }
          }
        },
        {
          name: '',
          type: 'value',
          splitLine: {
            show: false
          },
          axisLine: {
            onZero: true,
            lineStyle: {
              color: '#E5E7EC'
            }
          },
          axisLabel: {
            color: '#7B7E81',
            formatter: function (value) { //上图右边y轴
              return value >= 1000000 ? value / 1000000 + "M" : value > 9999 ? value / 1000 + "K" : toThousands(value);
            }
          }
        },
        {
          gridIndex: 1,
          name: '',
          type: 'value',
          splitLine: {
            show: false
          },
          axisLine: {
            onZero: true,
            lineStyle: {
              color: '#E5E7EC'
            }
          },
          axisLabel: {
            color: '#7B7E81',
            formatter: function (value) { //下左侧的评分值
              return value >= 1000000 ? value / 1000000 + "M" : value > 9999 ? value / 1000 + "K" : toThousands(value);
            }
          }
        },
        {
          gridIndex: 1,
          name: '',
          type: 'value',
          splitLine: {
            show: false
          },
          axisLine: {
            onZero: true,
            lineStyle: {
              color: '#E5E7EC'
            }
          },
          axisLabel: {
            color: '#7B7E81',
            formatter: function (value) { //下右侧的评论数
              return value >= 1000000 ? value / 1000000 + "M" : value > 9999 ? value / 1000 + "K" : toThousands(value);
            }
          }
        }
      ],
      color: ['#FFAE2D', '#5FB0FF', '#6EC952', '#909CF7', '#FF8C45', '#FB7A7A', '#62E3BE'],
      series: [
        {
          name: chrome.i18n.getMessage("keepa_price"),//'价格',
          type: 'line',
          symbolSize: 1,
          step: true,
          smooth: false,//true 为平滑曲线，false为直线
          itemStyle: {
            normal: {
              lineStyle: {
                width: 1.5,  // 设置线宽
                type: 'solid'  //'dotted'虚线 'solid'实线
              }
            }
          },
          data: result.data.keepa.price //[120, 132, 101, 134, 90, 230, 210]
        },
        {
          name: chrome.i18n.getMessage("keepa_bsrRanking"),//'BSR排名',
          type: 'line',
          symbolSize: 1,
          xAxisIndex: 0,
          yAxisIndex: 1,
          step: true,
          smooth: false,//true 为平滑曲线，false为直线
          symbol: 'none', //去掉折线图中的节点
          itemStyle: {
            normal: {
              lineStyle: {
                width: 1.5,  // 设置线宽
                type: 'solid'  //'dotted'虚线 'solid'实线
              }
            }
          },
          data: result.data.keepa.bsr //[220, 182, 191, 234, 290, 330, 310]
        },
        {
          name: chrome.i18n.getMessage("keepa_reviews"),//'评论数',
          type: 'line',
          symbolSize: 1,
          xAxisIndex: 3,
          yAxisIndex: 3,
          step: true,
          smooth: false,//true 为平滑曲线，false为直线
          itemStyle: {
            normal: {
              lineStyle: {
                width: 1.5,  // 设置线宽
                type: 'solid'  //'dotted'虚线 'solid'实线
              }
            }
          },
          data: result.data.keepa.reviews //[320, 332, 301, 334, 390, 330, 320]
        },
        {
          name: chrome.i18n.getMessage("keepa_rating"),//'评分',
          type: 'line',
          symbolSize: 1,
          xAxisIndex: 2,
          yAxisIndex: 2,
          step: true,
          smooth: false,//true 为平滑曲线，false为直线
          itemStyle: {
            normal: {
              lineStyle: {
                width: 1.5,  // 设置线宽
                type: 'solid'  //'dotted'虚线 'solid'实线
              }
            }
          },
          data: result.data.keepa.rating //[150, 232, 201, 154, 190, 330, 410]
        },
        {
          name: chrome.i18n.getMessage("keepa_seller"),//'卖家数',
          type: 'line',
          symbolSize: 1,
          xAxisIndex: 3,
          yAxisIndex: 3,
          step: true,
          smooth: false,//true 为平滑曲线，false为直线
          itemStyle: {
            normal: {
              lineStyle: {
                width: 1.5,  // 设置线宽
                type: 'solid'  //'dotted'虚线 'solid'实线
              }
            }
          },
          data: result.data.keepa.sellers //[10, 32, 31, 34, 30, 330, 220]
        },
        {
          name: chrome.i18n.getMessage("keepa_dealPrice"),//'Deal价格',
          type: 'scatter',
          symbol: 'circle',
          symbolSize: 10,
          xAxisIndex: 1,
          yAxisIndex: 1,
          step: true,
          smooth: false,//true 为平滑曲线，false为直线
          itemStyle: {
            normal: {
              lineStyle: {
                width: 1.5,  // 设置线宽
                type: 'solid'  //'dotted'虚线 'solid'实线
              }
            }
          },
          data: result.data.keepa.dealPrice //[820, 932, 901, 934, 1290, 1330, 1320]
        },
        {
          name: chrome.i18n.getMessage("keepa_buyboxPrice"),//'Buybox价格',
          type: 'scatter',
          symbol: 'circle',
          symbolSize: 10,
          //是否是阶梯线图。可以设置为 true 显示成阶梯线图，也支持设置成 'start', 'middle', 'end' 分别配置在当前点，当前点与下个点的中间点，下个点拐弯
          step: true,
          //是否平滑曲线显示。 如果是 boolean 类型，则表示是否开启平滑处理。如果是 number 类型（取值范围 0 到 1），表示平滑程度，越小表示越接近折线段，
          // 反之则反。设为 true 时相当于设为 0.5。
          smooth: true,//true 为平滑曲线，false为直线
          itemStyle: {
            normal: {
              lineStyle: {
                width: 1.5,  // 设置线宽
                type: 'solid'  //'dotted'虚线 'solid'实线
              }
            }
          },
          data: result.data.keepa.buyPrice //[821, 93, 601, 741, 170, 1370, 18]
        }
      ]
    };

    let hasLogo = false; //true为有logo渲染模式，反之是无logo渲染模式
    if (option && typeof option === "object") {
      // myChart.setOption(option, true);
      if (!hasLogo) {  //如果没有logo
        option.title.top = 60;
        option.title.right = 34;
        option.title.subtextStyle.rich.a = {};
        option.toolbox.top = 130;
        option.legend.top = 170;
      }

      myChart.setOption(option, true);
    }

    window.onresize = function () {
      myChart.resize();
    };
    //此处模拟加载数据
    setTimeout(function () {
      document.getElementsByClassName('chart-loading')[0].style.display = 'none';
    }, 10);


    // 配置时间范围列表，
    var range = {
      title: chrome.i18n.getMessage("keepa_select_range"),
      defaultRange: 180,  //默认值
      list: [
        {
          label: chrome.i18n.getMessage("keepa_select_range_180"),
          value: 180
        },
        {
          label: chrome.i18n.getMessage("keepa_select_range_365"),
          value: 365
        },
        {
          label: changeTotalDays(result.data.totalDays),
          value: -1
        }
      ],
      createHtml: function () {  //生成范围HTML
        var _this = this;
        var html = '<div class="select-range-title">' + this.title + '</div>';

        var paddingRight = details.current_locale === "en_US" || details.current_locale === "en" ? "0px" :
          details.current_locale === "ja" ? "0px" : "30px";

        html += '<div class="flex-w1 select-range" style="float: right;margin-top: -17px;padding-right: ' + paddingRight + '">';
        this.list.map(function (item) {
          if (item.value === _this.defaultRange) {
            html += '<a href="#" class="active" style="text-decoration:none" range="' + item.value + '" >' + item.label + '</a>'
          } else {
            html += '<a href="#" class="' + (item.value === _this.defaultRange ? 'active' : '') + '" style="text-decoration:none" range="' + item.value + '" >' + item.label + '</a>'
          }
        });
        html += '</div>';
        $('#range').html(html);

        //绑定点击事件
        $('#range').delegate('a', 'click', function () {
          myChart.clear();
          var range = $(this).attr('range');  //取得选中值
          //设置选中样式
          $('#range a').removeClass('active');
          $(this).addClass('active');

          var start = 0;
          if (Number(range) === 180) {
            start = result.data.range.half;
          }
          if (Number(range) === 365) {
            start = result.data.range.year;
          }

          //此处模拟更新图表
          option.dataZoom[0].start = start;
          option.dataZoom[1].start = start;
          myChart.setOption(option, true);
        })
      }
    };
    range.createHtml();

  } else {
    //这里需要跳转到缺省页
    window.location.href = chrome.extension.getURL('injects/error.html?error=' + escape(result.message));
  }

  console.log("Keepa插件加载成功：" + result.message);
}

function price(num) {
  num = (num || 0).toString();
  var result = '';

  var arrs;
  if (num.indexOf(".")) {
    arrs = num.split(".");
    num = arrs[0];
  }

  while (num.length > 3) {
    result = ',' + num.slice(-3) + result;
    num = num.slice(0, num.length - 3);
  }
  if (num) {
    result = num + result;
  }

  return result + (arrs[1] !== undefined ? "." + completionDecimal(arrs[1]) : ".00");
}

function toThousands(num) {
  num = (num || 0).toString(), result = '';

  var arrs;
  if (num.indexOf(".")) {
    arrs = num.split(".");
    num = arrs[0];
  }

  while (num.length > 3) {
    result = ',' + num.slice(-3) + result;
    num = num.slice(0, num.length - 3);
  }
  if (num) {
    result = num + result;
  }

  return result + (arrs[1] !== undefined ? "." + completionDecimal(arrs[1]) : "");
}

function completionDecimal(d) {
  if (d.length === 1) {
    d = d + "0"
  }
  return d;
}

function rounding(value) {
  if (value.indexOf(".") > -1) {
    return value.split(".")[0];
  }

  return value;
}

// 对Date的扩展，将 Date 转化为指定格式的String
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
// 例子：
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
Date.prototype.format = function (fmt) { //author: meizz
  var o = {
    "M+": this.getMonth() + 1,                 //月份
    "d+": this.getDate(),                    //日
    "h+": this.getHours(),                   //小时
    "m+": this.getMinutes(),                 //分
    "s+": this.getSeconds(),                 //秒
    "q+": Math.floor((this.getMonth() + 3) / 3), //季度
    "S": this.getMilliseconds()             //毫秒
  };
  if (/(y+)/.test(fmt))
    fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
  for (var k in o)
    if (new RegExp("(" + k + ")").test(fmt))
      fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
  return fmt;
};

//两个时间相差天数
function getDateDiff(date1, date2) {    //sDate1和sDate2是20180518格式
  //根据年 . 月 . 日的值创建Date对象
  var date1Obj = new Date(date1.substr(0, 4), date1.substr(4, 2), date1.substr(6));
  var date2Obj = new Date(date2.substr(0, 4), date2.substr(4, 2), date2.substr(6));
  var t1 = date1Obj.getTime();
  var t2 = date2Obj.getTime();
  var dateTime = 1000 * 60 * 60 * 24; //每一天的毫秒数
  var minusDays = Math.floor(((t2 - t1) / dateTime));//计算出两个日期的天数差
  return Math.abs(minusDays);//取绝对值
}

function changeTotalDays(days) {
  var str = chrome.i18n.getMessage("keepa_select_range_all");
  return str.replace("_", days);
}

